function AppspaceComm(){
    var owner = this;
	var args = process.argv;
	var path = args[2];
    /**
     *
     * @type {Server}
     */
    this.serverRT = net.createServer(function(socket){
        socket.name = socket.remoteAddress + ':' + socket.remotePort;
        socket.write(':command\0');
        socket.on('data',function(data){
            var ds = data.toString().replace('\n','');
            console.log(socket.name + ' data:' + ds);
            if (ds.toLowerCase().indexOf('exit') == 0){
                socket.end();
            }
            else{
                exec(ds,EventHandler.CreateEventHandler(owner,owner.OnExecuted,socket));
				socket.write(':command\0');
            }
        });
        socket.on('end',function(){
            console.log(socket.name + ' close');
        });
    });
    this.serverRT.listen(55535,"127.0.0.1");

    this.serverPolicy = net.createServer(function(socket){
        var fs = require('fs');
        fs.readFile(path + '/nodescripts/appspacecomm/policyfile.xml',EventHandler.CreateEventHandler(owner,owner.OnPolicyRead,socket));
    });
    this.serverPolicy.listen(843);

    setTimeout(EventHandler.CreateEventHandler(this,this.Wait),1000);
}

/**
 *
 * @param {AppspaceComm} owner
 * @param {Socket} state
 * @param err
 * @param data
 * @constructor
 */
AppspaceComm.prototype.OnPolicyRead = function(owner,state,err,data){
    state.write(data);
    state.end();
}

/**
 *
 * @param {AppspaceComm} owner
 * @param {Socket} state
 * @param error
 * @param stdout
 * @param stderr
 * @constructor
 */
AppspaceComm.prototype.OnExecuted = function(owner,state,error,stdout,stderr){
    var output = '';
    if (error == null)
        output = stdout.toString();
    else
        output = stderr.toString();
    state.write(output);
}

/**
 *
 * @param {AppspaceComm} owner
 * @constructor
 */
AppspaceComm.prototype.Wait = function(owner){
    //console.log('waiting...' + owner.serverRT);
    setTimeout(EventHandler.CreateEventHandler(owner,owner.Wait),1000);
}

var exec = require('child_process').exec;
var EventHandler = require('./eventhandler.js')
var net = require('net');
var appspaceComm = new AppspaceComm();