/**
 * Created by syedhusain on 10/28/13.
 */
function DeployedTask(){
    this.AccountId = 0;
    this.Active = false;
    this.ClassificationId = '';
    this.CreatedDate = new Date();
    this.Description = '';
    this.Id = 0;
    this.Name = '';
    this.QualifiedName = '';
    this.RequireReboot = false;
    this.TaskClass = 0; //enum
    this.TaskScheduleType = 0; //enum
    this.UpdatedDate = new Date();
    this.FailedCount = 0;
    this.Issued = new Date();
    this.SuccessCount = 0;
    this.TemplateTaskId = 0;
    /** @type {Definition[]} */
    this.Definitions = [];
    this.DeploymentTargets = null;
    /** @type {Parameter[]} */
    this.Parameters = [];
    /** @type {Schedule} */
    this.Schedule = null;

    /** @type {Number} */
    this.baseExecuteDate = null;
    /** @type {Number} */
    this.virtualExecuteDate = null;
}

var Definition = require('../adm/definition');
var Schedule = require('../adm/schedule');
var Parameter = require('../adm/parameter');
module.exports = DeployedTask;