/**
 * Created by syedhusain on 10/28/13.
 */
function Parser()
{

}

Parser.prototype.convertJsonTimespanToDate = function(timestamp){
    var res = timestamp;
    res = res.replace('P','');
    var day = '';
    var hour = '';
    var minutes = '';

    var dayIndex = res.indexOf('D');
    if (dayIndex > -1){
        day = res.substring(0,dayIndex + 1);
        res = res.replace(day,'');
        day = day.replace('D','');
    }

    res = res.replace('T','');
    var hourIndex = res.indexOf('H');
    if (hourIndex > -1){
        hour = res.substring(0,hourIndex + 1);
        res = res.replace(hour,'');
        hour = hour.replace('H','');
    }

    var minuteIndex = res.indexOf('M');
    if (minuteIndex > -1){
        minutes = res.substring(0,minuteIndex + 1);
        res = res.replace(minutes,'');
        minutes = minutes.replace('M','');
    }

    return {Day: day * 1, Hour: hour * 1, Minute: minutes *1};
}

Parser.prototype.parseServerDate = function(raw,option){
    var treatUTCasLocal = false;
    if (option != null){
        if (option.treatUTCasLocal != null && option.treatUTCasLocal == true){
            treatUTCasLocal = true;
        }
    }
    if (raw == null || raw == '')
        return null;

    var createdDate = raw;
    createdDate = createdDate.substring(6,createdDate.length -2);
    var res = new Date();
    res.setTime(createdDate);

    if (treatUTCasLocal == true){
        res = new Date(res.getUTCFullYear(),res.getUTCMonth(),res.getUTCDate(),res.getUTCHours(), res.getUTCMinutes(), res.getUTCSeconds());
    }

    return res;
}

var parser = new Parser();

module.exports = parser;