#include <stdio.h>
#include <string.h>

int main (int argc, char ** argv){
	char OFF[] = "0";
	char ON[] = "1";
	char CHECK[] = "2";
	
	if (strcmp(argv[1], ON) == 0) {
		printf("ON\n");
		system("xmodmap -e 'keycode   9 = Escape NoSymbol Escape'");
		system("xmodmap -e 'keycode  37 = Control_L NoSymbol Control_L'");
		system("xmodmap -e 'keycode  64 = Alt_L Meta_L Alt_L Meta_L'");
		system("xmodmap -e 'keycode  67 = F1 XF86_Switch_VT_1 F1 XF86_Switch_VT_1'");
		system("xmodmap -e 'keycode  68 = F2 XF86_Switch_VT_2 F2 XF86_Switch_VT_2'");
		system("xmodmap -e 'keycode  69 = F3 XF86_Switch_VT_3 F3 XF86_Switch_VT_3'");
		system("xmodmap -e 'keycode  70 = F4 XF86_Switch_VT_4 F4 XF86_Switch_VT_4'");
		system("xmodmap -e 'keycode  71 = F5 XF86_Switch_VT_5 F5 XF86_Switch_VT_5'");
		system("xmodmap -e 'keycode  72 = F6 XF86_Switch_VT_6 F6 XF86_Switch_VT_6'");
		system("xmodmap -e 'keycode  73 = F7 XF86_Switch_VT_7 F7 XF86_Switch_VT_7'");
		system("xmodmap -e 'keycode  74 = F8 XF86_Switch_VT_8 F8 XF86_Switch_VT_8'");
		system("xmodmap -e 'keycode  75 = F9 XF86_Switch_VT_9 F9 XF86_Switch_VT_9'");
		system("xmodmap -e 'keycode  76 = F10 XF86_Switch_VT_10 F10 XF86_Switch_VT_10'");
		system("xmodmap -e 'keycode  95 = F11 XF86_Switch_VT_11 F11 XF86_Switch_VT_11'");
		system("xmodmap -e 'keycode  96 = F12 XF86_Switch_VT_12 F12 XF86_Switch_VT_12'");
		system("xmodmap -e 'keycode 105 = Control_R NoSymbol Control_R'");
		system("xmodmap -e 'keycode 108 = Alt_R Meta_R Alt_R Meta_R'");
	}
	else if (strcmp(argv[1], OFF) == 0)	{
		printf("OFF\n");
		system("xmodmap -e 'keycode   9 ='");
		system("xmodmap -e 'keycode  37 ='");
		system("xmodmap -e 'keycode  64 ='");
		system("xmodmap -e 'keycode  67 ='");
		system("xmodmap -e 'keycode  68 ='");
		system("xmodmap -e 'keycode  69 ='");
		system("xmodmap -e 'keycode  70 ='");
		system("xmodmap -e 'keycode  71 ='");
		system("xmodmap -e 'keycode  72 ='");
		system("xmodmap -e 'keycode  73 ='");
		system("xmodmap -e 'keycode  74 ='");
		system("xmodmap -e 'keycode  75 ='");
		system("xmodmap -e 'keycode  76 ='");
		system("xmodmap -e 'keycode  95 ='");
		system("xmodmap -e 'keycode  96 ='");
		system("xmodmap -e 'keycode 105 ='");
		system("xmodmap -e 'keycode 108 ='");
	}
	else if (strcmp(argv[1], CHECK) == 0) {
		// 1 - keys are disabled 
		// 0 - keys are enabled 
		// anything else it is an error
		printf("CHECK: %i\n", keymapCheck());
	}

	return 0;
}

int keymapCheck () {
	system("xmodmap -pke > keymap.dat");
	char keyString[1024];
	FILE *fp = fopen("keymap.dat", "r");
	
	if (fp == NULL) {
		//file cannot be opened
		return 2;
	}
	
	while (fgets(keyString, 1024, fp)) {
		if (strstr(keyString, "keycode  64 =") != NULL) {
			if (keyString[14] == ' ' || keyString[14] == '\0') {
				system("rm keymap.dat");
				//keycode enabled
				return 1;
			}
			else {
				system("rm keymap.dat");
				//keycode disabled
				return 0;
			}
				
		}
	}
	
	system("rm keymap.dat");
	// keycode not found
	return 3;
}
	

