#!/bin/bash

#disable api authentication
if [ -f /usr/lib/python2.7/site-packages/webgui/webgui.cfg ] ; then
	sed -i 's/LOCAL_AUTH=True/LOCAL_AUTH=False/g' /usr/lib/python2.7/site-packages/webgui/webgui.cfg
fi

#init.d
[[ -f appspace ]] && cp -f appspace /etc/init.d/appspace
chkconfig --del appspacescript
chkconfig --del appspace
chkconfig --add appspace && chkconfig --level 2345 appspace on
	
#xinitrc
[[ -f xinitrc ]] && cp -f xinitrc /etc/xdg/xfce4/xinitrc

#xfce keyboard
[[ -d /home/user/.config/xfce4/xfconf/xfce-perchannel-xml ]] && : || su -u user mkdir -p /home/user/.config/xfce4/xfconf/xfce-perchannel-xml
chown -R user:user /home/user/.config #change owner to user, just in case
[[ -d /home/user/.cache ]] && rm -fr /home/user/.cache #suggested by CPG
[[ -f xfce4-keyboard-shortcuts.xml  ]] && cp -f xfce4-keyboard-shortcuts.xml /home/user/.config/xfce4/xfconf/xfce-perchannel-xml/xfce4-keyboard-shortcuts.xml

#autologin
cpgmgt_methodcall.py -o LoginManager -m Set -a "autologin enable"
cpgmgt_methodcall.py -o LoginManager -m SyncConfig -a "autologin"
if [ -f /home/appspace/autologin ] ; then
 [[ -f /etc/sysconfig/desktop ]] && rm -f /etc/sysconfig/desktop
 ln -s /home/appspace/autologin /etc/sysconfig/desktop
fi

#autologin v2
curl -k -X PUT -H "Content-Type:application/json" --data '{"mode": 2,"username": "user"}' https://localhost/api/v3/system/autologin

#flash player trust
[[ -d /etc/adobe/FlashPlayerTrust/ ]] && rm -rf /etc/adobe/FlashPlayerTrust/ && rm -rf /etc/adobe
mkdir -p /etc/adobe/FlashPlayerTrust/
echo "/apps/nexus2" > /etc/adobe/FlashPlayerTrust/trust.cfg	

#disable input button
[[ -f cisco_edge340_keymap ]] && cp -f cisco_edge340_keymap /etc/rc_keymaps/cisco_edge340

echo "Re-map A/Blue button to KEY_HELP and ? button to KEY_BLUE"
#re-map A/Blue button to help
#re-map ? button to blue (to reimage device)
curl -X PUT -k -d '{"enabled": "true", "keymap": {"A":"KEY_HELP","help":"KEY_BLUE"}}' 'https://127.0.0.1/api/v3/system/ir'
curl -X PUT -k -d '{"enabled": "true", "keymap": {"input":""}}' 'https://127.0.0.1/api/v3/system/ir'
