#!/bin/bash
_tempPath="/tmp/appspace"

d=$(date +%m/%d/%y-%T)
path="/apps/nexus2/Logs/rebootlog"


if [ -d /apps/nexus2/Logs ] ; then
	:
else
	mkdir /apps/nexus2/Logs
fi

d=$(date +%m/%d/%y-%T)
echo "$d: Running rebootscript" >> $path

d=$(date +%m/%d/%y-%T)
echo "$d: Kill chrome" >> $path
killall -2 chrome
sleep 1
d=$(date +%m/%d/%y-%T)
echo "$d: Running /apps/nexus2/killallappspaceprocess.sh" >> $path
/bin/bash /apps/nexus2/killallappspaceprocess.sh
sleep 1

d=$(date +%m/%d/%y-%T)
echo "$d: Backup all temporary log files" >> $path
if [ -f $_tempPath/downloadmanagerlog.txt ] ; then
	cp -f $_tempPath/downloadmanagerlog.txt /apps/nexus2/Logs/downloadmanagerlog.txt
fi

if [ -f $_tempPath/appspacenode.log ] ; then
	cp -f $_tempPath/appspacenode.log /apps/nexus2/Logs/appspacenode.log
fi


ts=$(mount | grep /apps/nexus2/contentrepo)
if [ "$ts" != "" ] ; then
	d=$(date +%m/%d/%y-%T)
	echo "$d: Running fsck on /apps/nexus2/contentrepo" >> $path
	fsck /apps/nexus2/contentrepo
	
	d=$(date +%m/%d/%y-%T)
	echo "$d: Unmounting /apps/nexus2/contentrepo" >> $path
	umount /apps/nexus2/contentrepo
fi



d=$(date +%m/%d/%y-%T)
echo "$d: Running normal reboot" >> $path
reboot
sleep 10
d=$(date +%m/%d/%y-%T)
echo "$d: Device doesn't reboot on normal reboot command. Running force reboot" >> $path
reboot -n -f