#!/bin/bash

[[ -d /tmp/appspace ]] && : || mkdir -p /tmp/appspace

#Restart xinetd
kill -TERM $(pidof "xinetd")
sleep 1
/usr/local/cisco/sbin/xinetd &

if [ -d /nexusstorage ] ; then
	rm -rf /nexusstorage
fi

if [ -e /apps/nexus2/doregister ] ; then
	processtocheck=`ps aux | grep chrome | grep -v grep`
	counter=0
	while [ "$processtocheck" = "" ]
	do
		sleep 1		
		counter=$(($counter+1))
		if [ $counter -gt 30 ]; then
			break
		fi
		processtocheck=`ps aux | grep chrome | grep -v grep`
	done
	rm -rf /apps/nexus2/doregister
	echo "16:1:Starting AppSpace registration" > "/apps/nexus2/registerlog"
fi

if [ -f "/apps/twscreen/TwDriver" ] ; then
	kill -TERM $(pidof "TwDriver")
	if [ -f "/apps/twscreen/TwDriver" ]; then
		sleep 1
		/apps/twscreen/TwDriver &
	fi
fi

useexternal=false
check=$(cat /apps/nexus2/node.dat | grep externalstorage=true)
if [ "$check" != "" ] ; then
	useexternal=true
fi

if [ $useexternal = true ] ; then
	/bin/bash /apps/nexus2/storagecontroller.sh mount
fi

crontab -u root /apps/nexus2/crontab

if [ -f /apps/nexus2/unclutter/unclutter ] ; then
	/apps/nexus2/unclutter/unclutter &
fi

[[ -f /apps/nexus2/appspacenodeservicesholder.sh ]] && /bin/bash /apps/nexus2/appspacenodeservicesholder.sh -enableappspaceservice -enableremotesocketservice -enablefileserverservice -enablepm -devicetype=e300 &

[[ -f /apps/nexus2/admholder.sh ]] && /bin/bash /apps/nexus2/admholder.sh &

[[ -f /apps/nexus2/dmholder.sh ]] && /bin/bash /apps/nexus2/dmholder.sh &