#!/bin/bash
function CopyFiles()
{
	cp -f internal-version.dat /apps/nexus2/internal-version.dat
	
	[[ -d /apps/nexus2/externalfiles ]] && rm -rf /apps/nexus2/externalfiles
	mkdir -p /apps/nexus2/externalfiles

	cp -f scripts/player-holder.html /apps/nexus2/player-holder.html
	cp -f scripts/swfobject.js /apps/nexus2/swfobject.js
	cp -f scripts/jquery-1.11.1.min.js /apps/nexus2/jquery-1.11.1.min.js
        
	cp -f player/nexusmediaplayer.swf /apps/nexus2/nexusmediaplayer.swf
	cp -f player/nexusmediaplayer.core-landscape.swf /apps/nexus2/nexusmediaplayer.core-landscape.swf
	
	cp -f scripts/downloadmanagerEdge300.sh /apps/nexus2/downloadmanageredge300.sh && dos2unix /apps/nexus2/downloadmanageredge300.sh > /dev/null && chmod 777 /apps/nexus2/downloadmanageredge300.sh
	cp -f scripts/dmholder.sh /apps/nexus2/dmholder.sh && dos2unix /apps/nexus2/dmholder.sh > /dev/null && chmod 777 /apps/nexus2/dmholder.sh
	
	cp -f scripts/policyfile.xml /apps/nexus2/policyfile.xml && dos2unix /apps/nexus2/policyfile.xml > /dev/null
	cp -f scripts/remoteterminal.sh /apps/nexus2/remoteterminal.sh && dos2unix /apps/nexus2/remoteterminal.sh > /dev/null && chmod 777 /apps/nexus2/remoteterminal.sh
	cp -f scripts/servepolicyfile.sh /apps/nexus2/servepolicyfile.sh && dos2unix /apps/nexus2/servepolicyfile.sh > /dev/null && chmod 777 /apps/nexus2/servepolicyfile.sh
	cp -f scripts/startup.sh /apps/nexus2/startup.sh && dos2unix /apps/nexus2/startup.sh > /dev/null && chmod 777 /apps/nexus2/startup.sh
	cp -f scripts/ws.sh /apps/nexus2/ws.sh && dos2unix /apps/nexus2/ws.sh > /dev/null && chmod 777 /apps/nexus2/ws.sh
	cp -f scripts/logger.sh /apps/nexus2/logger.sh && dos2unix /apps/nexus2/logger.sh > /dev/null && chmod 777 /apps/nexus2/logger.sh
	cp -f scripts/rebootscript.sh /apps/nexus2/rebootscript.sh && dos2unix /apps/nexus2/rebootscript.sh > /dev/null && chmod 777 /apps/nexus2/rebootscript.sh
	cp -f scripts/appspacemonitor.sh /apps/nexus2/appspacemonitor.sh && dos2unix /apps/nexus2/appspacemonitor.sh > /dev/null && chmod 777 /apps/nexus2/appspacemonitor.sh
	cp -f scripts/storagecontroller.sh /apps/nexus2/storagecontroller.sh && dos2unix /apps/nexus2/storagecontroller.sh > /dev/null && chmod 777 /apps/nexus2/storagecontroller.sh
	cp -f scripts/installation_300.sh /apps/nexus2/installation_300.sh && dos2unix /apps/nexus2/installation_300.sh > /dev/null && chmod 777 /apps/nexus2/installation_300.sh
	cp -f scripts/installation.sh /apps/nexus2/installation.sh && dos2unix /apps/nexus2/installation.sh > /dev/null && chmod 777 /apps/nexus2/installation.sh
	cp -f scripts/switchmode.sh /apps/nexus2/switchmode.sh && dos2unix /apps/nexus2/switchmode.sh > /dev/null && chmod 777 /apps/nexus2/switchmode.sh
	
	cp -f scripts/killallappspaceprocess.sh /apps/nexus2/killallappspaceprocess.sh	 && dos2unix /apps/nexus2/killallappspaceprocess.sh > /dev/null && chmod 777 /apps/nexus2/killallappspaceprocess.sh
	cp -f scripts/crontab /apps/nexus2/crontab	 && dos2unix /apps/nexus2/crontab > /dev/null
	cp -f patch/functionkeys/keymap /apps/nexus2/keymap && chmod 777 /apps/nexus2/keymap	
	
	cp -f scripts/nexuspfconf.sh /etc/xinetd.d/nexuspfconf && dos2unix /etc/xinetd.d/nexuspfconf > /dev/null && chmod 777 /etc/xinetd.d/nexuspfconf && cp -f /etc/xinetd.d/nexuspfconf /apps/nexus2/externalfiles/
	cp -f scripts/nexusrtconf.sh /etc/xinetd.d/nexusrtconf && dos2unix /etc/xinetd.d/nexusrtconf > /dev/null && chmod 777 /etc/xinetd.d/nexusrtconf && cp -f /etc/xinetd.d/nexusrtconf /apps/nexus2/externalfiles/
	cp -f scripts/nexusstatconf.sh /etc/xinetd.d/nexusstatconf && dos2unix /etc/xinetd.d/nexusstatconf > /dev/null && chmod 777 /etc/xinetd.d/nexusstatconf && cp -f /etc/xinetd.d/nexusstatconf /apps/nexus2/externalfiles/
	#cp -f scripts/nexuswsconf.sh /etc/xinetd.d/nexuswsconf && dos2unix /etc/xinetd.d/nexuswsconf > /dev/null && chmod 777 /etc/xinetd.d/nexuswsconf	
	
	cp -f scripts/node /apps/nexus2/node && chmod 777 /apps/nexus2/node
	cp -f scripts/admholder.sh /apps/nexus2/admholder.sh && dos2unix /apps/nexus2/admholder.sh > /dev/null && chmod 777 /apps/nexus2/admholder.sh
	cp -f scripts/appspacenodeservicesholder.sh /apps/nexus2/appspacenodeservicesholder.sh && dos2unix /apps/nexus2/appspacenodeservicesholder.sh > /dev/null && chmod 777 /apps/nexus2/appspacenodeservicesholder.sh
	
	cp -f scripts/externalfiles/startxfce4 /scripts/startxfce4 && dos2unix /scripts/startxfce4 > /dev/null && chmod 777 /scripts/startxfce4 && cp -f /scripts/startxfce4 /apps/nexus2/externalfiles/
	cp -f scripts/externalfiles/services /etc/services && dos2unix /etc/services > /dev/null && chmod 777 /etc/services && cp -f /etc/services /apps/nexus2/externalfiles/
	
	cp -f scripts/externalfiles/startxfce4.original /apps/nexus2/externalfiles && dos2unix /apps/nexus2/externalfiles/startxfce4.original > /dev/null && chmod 777 /apps/nexus2/externalfiles/startxfce4.original
	cp -f scripts/externalfiles/services.original /apps/nexus2/externalfiles && dos2unix /apps/nexus2/externalfiles/services.original > /dev/null && chmod 777 /apps/nexus2/externalfiles/services.original
	
	cp -f patch/cursor/left_ptr_backup /usr/share/icons/default/cursors/left_ptr
	
	[[ -d /apps/nexus2/unclutter ]] && rm -rf /apps/nexus2/unclutter
	
	[[ -f patch/cursor/unclutter.tar ]] && mkdir -p /apps/nexus2/unclutter && tar -xvf patch/cursor/unclutter.tar -C /apps/nexus2/unclutter/
	
	[[ -d /apps/nexus2/pages ]] && rm -rf /apps/nexus2/pages
	mkdir /apps/nexus2/pages
	[[ -d pages/pm ]] && cp -rf pages/pm /apps/nexus2/pages/	
	[[ -d pages/splash ]] && cp -rf pages/splash /apps/nexus2/pages/
	
	if [ -f patch/rs232/rs232 ] ; then
		cp -f patch/rs232/rs232 /apps/nexus2/rs232 && chmod 777 /apps/nexus2/rs232
		cp -f patch/rs232/rs232holder /apps/nexus2/rs232holder && dos2unix /apps/nexus2/rs232holder > /dev/null && chmod 777 /apps/nexus2/rs232holder
	fi
}

function ConfigureFlashTrust()
{
	[[ -d /etc/adobe/FlashPlayerTrust/ ]] && rm -rf /etc/adobe/FlashPlayerTrust/ && rm -rf /etc/adobe
	mkdir -p /etc/adobe/FlashPlayerTrust/
	echo "/apps/nexus2" > /etc/adobe/FlashPlayerTrust/trust.cfg	
}

function ConfigureXdotool()
{
	[[ -f /apps/nexus2/xdotool ]] && rm -rf /apps/nexus2/xdotool
	[[ -d /apps/nexus2/xdotool ]] && rm -rf /apps/nexus2/xdotool

	if [ -f patch/xdotool.tar ] ; then
		tar xvf patch/xdotool.tar -C /apps/nexus2/
		[[ -f /apps/nexus2/xdotool/xdotool ]] && chmod 777 /apps/nexus2/xdotool/xdotool
		[[ -f /apps/nexus2/xdotool/libxdo.so.2 ]] && ln -s /apps/nexus2/xdotool/libxdo.so.2 /apps/nexus2/xdotool/libxdo.so
	fi
}

function ConfigureNodeProjects()
{
	if [ -d nodescripts/appspacenode ] ; then
		[[ -d /apps/nexus2/nodescripts/appspacenode ]] && : || mkdir -p /apps/nexus2/nodescripts/appspacenode
		cp -rf nodescripts/appspacenode/* /apps/nexus2/nodescripts/appspacenode/
	fi
	
	if [ -d nodescripts/appspacenodeservices ] ; then
		[[ -d /apps/nexus2/nodescripts/appspacenodeservices ]] && : || mkdir -p /apps/nexus2/nodescripts/appspacenodeservices
		cp -rf nodescripts/appspacenodeservices/* /apps/nexus2/nodescripts/appspacenodeservices/
	fi
}

function RemoveLegacyConfiguration()
{
	if [ -d /nexusstorage ] ; then
		touch /nexusstorage/install-reboot
		echo "externalstorage=true" >> /apps/nexus2/node.dat
		rm -f /apps/nexus2/DMscript.txt
		rm -f /apps/nexus2/DMapptimestamp.js
		rm -rf /nexusstorage/contentrepo
		cp -f /nexusstorage/node.dat /apps/nexus2/node.dat
		cp -rf /nexusstorage/Logs /apps/nexus2/Logs
		cp -f /nexusstorage/version.inf /apps/nexus2/version.inf
	fi
	
	[[ -f /etc/xinetd.d/nexuswsconf ]] && rm -rf /etc/xinetd.d/nexuswsconf
}

function ProcessData()
{
	local procDataPath="/tmp/process.data"
	local message="$1"
	touch "$procDataPath"
	echo "$message" > "$procDataPath"
	local procData=""
	dos2unix "$procDataPath" > /dev/null
	while read processdataline
	do
		procData="$processdataline"
	done < "$procDataPath"
	
	_REPLY="$procData"								
	rm -rf "$procDataPath"
}

function GetMACAddress(){
	REPLY=""
	
	local macraw=`ifconfig | grep eth0`
	macraw=`echo $macraw | sed 's|eth0||'`
	macraw=`echo $macraw | sed 's|Link encap:Ethernet||'`
	macraw=`echo $macraw | sed 's|HWaddr||'`
	macraw=`echo $macraw | sed 's/ *$//g'`
	ProcessData "$macraw"
	macraw="$_REPLY"
	REPLY="$macraw"
}

function SendDeviceType()
{
	local countline=0
	local id=""
	local appspaceip=""
	local devicetype=""
	
	while read -r line
	do
		if [[ $countline == 0 ]] ; then
			id="$line"
		elif [[ $countline == 2 ]] ; then
			appspaceip="$line"
		elif [[ $countline == 1 ]] ; then
			devicetype="$line"
		fi
		countline=$(($countline+1))
	done < /apps/nexus2/node.dat
	
	local res=$(curl -L -k --connect-timeout 30 --url "$appspaceip/integrationwebservices/ConfigScriptHandler.ashx" -d "operation=setproperty&key=Player.Model.Name&value=EDGE300&type=player&id=$id")
}

function CheckLegacyId()
{
	
	local countline=0
	local id=""
	local appspaceip=""
	
	while read -r line
	do
		if [[ $countline == 0 ]] ; then
			id="$line"
		elif [[ $countline == 2 ]] ; then
			appspaceip="$line"
		fi
		countline=$(($countline+1))
	done < /apps/nexus2/node.dat
	
	if [ `echo "$id" | grep "^[0-9]*$"` ]; then
		GetMACAddress
		local mac="$REPLY"
		local res=$(curl -L -k --connect-timeout 30 --url "$appspaceip/integrationwebservices/licensehandler.ashx" -d "query=license.getdeviceguidfromlegacy&pid=$id&di=$mac")
		if [ "$res" = "" ] ; then
			:
		elif [[ "$res" = *"API must"* ]] ; then
			:
		else
			countline=0
			touch /tmp/node.dat.tmp
			while read -r line
			do
				if [[ $countline == 0 ]] ; then
					echo "$res" >> /tmp/node.dat.tmp
				else
					echo "$line" >> /tmp/node.dat.tmp
				fi
				countline=$(($countline+1))
			done < "/apps/nexus2/node.dat"
			cp -f /tmp/node.dat.tmp /apps/nexus2/node.dat
			rm -f /tmp/node.dat.tmp
		fi
	fi
}

function Start()
{
	[[ -d /apps/nexus2 ]] && : || mkdir -p /apps/nexus2
	
	if [ "$1" = "clearworkingfolder" ] ; then
		rm -rf $(echo /apps/nexus2/* | tr " " "\n" | grep -v contentrepo | tr "\n" " ")
	fi
	
	CopyFiles
	ConfigureFlashTrust
	ConfigureNodeProjects
	ConfigureXdotool
	RemoveLegacyConfiguration
	CheckLegacyId
	SendDeviceType
	touch /apps/nexus2/install-reboot
}

Start $*