var DeviceType = require('../../util/devicetype.js');
var EventHandler = require('../../util/eventhandler.js');
var fs = require('fs');

function PMUtil(){
    
    var readyStartHandler = null;
	
	this.isReadyToStartHandler = function(calle,state){
        calle.isReadyToStart(state.devicetype,state.callback);
    };
	
    this.isReadyToStart = function(devicetype,callback){
		console.log('is ready to start?');
        if (devicetype === DeviceType.Edge300 || devicetype === DeviceType.Edge340){
            callback();
            return;   
        }
        
        if (devicetype === DeviceType.DMP4310){
            var filetocheck = "/tmp/ftproot/usb_1/applicationloaded";
            fs.readFile(filetocheck,EventHandler.CreateEventHandler(this,this.onFileReadHandler,{callbacksuccess:this.readyToStartSuccess,callbackfail:this.readyToStartFail,callback:callback,devicetype:devicetype}));
        }
    };
	
	this.onFileReadHandler = function(calle,state,err,data){
        if (err === null){//file exists
            state.callbacksuccess(calle,state);
        }else{//file doesn't exists
            state.callbackfail(calle,state);
        }
    };
    
    this.readyToStartSuccess = function(calle,state){
        state.callback();
    };
    
    this.readyToStartFail = function(calle,state){
        setTimeout(EventHandler.CreateEventHandler(calle,calle.isReadyToStartHandler,{devicetype:state.devicetype,callback:state.callback}),1000);
    };
    
    
}

var pmUtil = new PMUtil();
module.exports = pmUtil;
