#!/bin/sh

Main()
{
	local prevVal=""
	local message=""
	local location=""
	for i in $*
	do
		if [[ "$i" == -* ]] ; then
			prevVal="$i"
		elif [ "$prevVal" = "-message" ]; then
			if [ "$message" != "" ] ; then
				message="$message $i"
			else
				message="$i"
			fi
		elif [ "$prevVal" = "-location" ]; then
			location="$i"
		fi
	done
	
	if [ "$message" != "" -a "$location" != "" ] ; then
		
		OLDIFS=$IFS
		local line=`stat -t "$location"`
		unset TEMPARR
		IFS=' ' read -ra TEMPARR <<< "$line"
		local logSize="${TEMPARR[1]}"
		IFS=$OLDIFS			
		if [ ${logSize} -gt 30240000 ] ; then
			rm -f "$location"
		fi
		
		echo "$message" >> "$location"
	fi
}

Main $*