#!/bin/bash

function mountstorage(){
	unmountstorage
	local listofdevices=`/usr/local/cisco/sbin/blkid -o device /dev/sd*`
	for i in $listofdevices
	do
		if [ "$(echo $i | grep /dev/sda)" = "" ] ; then
			echo "Mounting $i to /apps/nexus2/contentrepo"
			mount $i /apps/nexus2/contentrepo
			kill -9 $(pidof chrome)
			break
		fi
	done
}

function unmountstorage(){
	local check=$(mount | grep /apps/nexus2/contentrepo)
	if [ "$check" != "" ] ; then
		echo "Unmounting /apps/nexus2/contentrepo"
		umount /apps/nexus2/contentrepo
		kill -9 $(pidof chrome)
	fi
}

operation="$1"
case "$operation" in
	"mount")
		mountstorage
	;;
	"unmount")
		unmountstorage
	;;
	*)
	;;
esac
