#!/bin/bash

function CopyFiles()
{
	
	cp -f internal-version.dat /home/appspace/internal-version.dat
	
	[[ -d /home/appspace/externalfiles ]] && rm -rf /home/appspace/externalfiles
	mkdir -p /home/appspace/externalfiles
	
	cp -f scripts/externalfiles/xinitrc.original /home/appspace/externalfiles/ && dos2unix /home/appspace/externalfiles/xinitrc.original > /dev/null && chmod a+rwx /home/appspace/externalfiles/xinitrc.original	
	cp -f scripts/externalfiles/xinitrc /home/appspace/externalfiles/ && dos2unix /home/appspace/externalfiles/xinitrc > /dev/null && chmod a+rwx /home/appspace/externalfiles/xinitrc
	cp -f scripts/externalfiles/xfce4-keyboard-shortcuts.xml.original /home/appspace/externalfiles/ && dos2unix /home/appspace/externalfiles/xfce4-keyboard-shortcuts.xml.original > /dev/null
	cp -f scripts/externalfiles/xfce4-keyboard-shortcuts.xml /home/appspace/externalfiles/ && dos2unix /home/appspace/externalfiles/xfce4-keyboard-shortcuts.xml > /dev/null
	cp -f scripts/externalfiles/appspace  /home/appspace/externalfiles/ && dos2unix /home/appspace/externalfiles/appspace > /dev/null && chmod a+rwx /home/appspace/externalfiles/appspace
	cp -f scripts/externalfiles/cisco_edge340_keymap /home/appspace/externalfiles/ && dos2unix /home/appspace/externalfiles/cisco_edge340_keymap > /dev/null
	cp -f scripts/externalfiles/cisco_edge340_keymap.original /home/appspace/externalfiles/ && dos2unix /home/appspace/externalfiles/cisco_edge340_keymap.original > /dev/null
	cp -f scripts/externalfiles/setup.340.sh /home/appspace/externalfiles/ && dos2unix /home/appspace/externalfiles/setup.340.sh > /dev/null && chmod a+rwx /home/appspace/externalfiles/setup.340.sh
	
	if [ -f /home/appspace/externalfiles/setup.340.sh ] ; then
		pushd /home/appspace/externalfiles
		/bin/bash setup.340.sh
		popd > /dev/null
	fi
	
	[[ -d /home/appspace/patch ]] && rm -rf /home/appspace/patch
	mkdir -p /home/appspace/patch
	
	[[ -f patch/libxdo-2.20110530.1-1.fc16.i686.rpm ]] && cp -f patch/libxdo-2.20110530.1-1.fc16.i686.rpm /home/appspace/patch/
	[[ -f patch/xdotool-2.20110530.1-1.fc16.i686.rpm ]] && cp -f patch/xdotool-2.20110530.1-1.fc16.i686.rpm /home/appspace/patch/
	[[ -f patch/cursor/unclutter.tar ]] && cp -f patch/cursor/unclutter.tar /home/appspace/patch/
	[[ -f patch/setup.340.sh ]] && cp -f patch/setup.340.sh /home/appspace/patch/ && dos2unix /home/appspace/patch/setup.340.sh && chmod a+rwx /home/appspace/patch/setup.340.sh
	
	if [ -f /home/appspace/patch/setup.340.sh ] ; then
		pushd /home/appspace/patch/
		/bin/bash setup.340.sh
		popd > /dev/null
	fi
	
	
	cp -f scripts/player-holder.html /home/appspace/player-holder.html
	cp -f scripts/swfobject.js /home/appspace/swfobject.js
	cp -f scripts/jquery-1.11.1.min.js /home/appspace/jquery-1.11.1.min.js
	cp -f player/nexusmediaplayer.swf /home/appspace/nexusmediaplayer.swf
	cp -f player/nexusmediaplayer.swf /home/appspace/nexusmediaplayer-landscape.swf
	cp -f player/nexusmediaplayer-portrait.swf /home/appspace/nexusmediaplayer-portrait.swf
	cp -f player/nexusmediaplayer.core-landscape.swf /home/appspace/nexusmediaplayer.core-landscape.swf
	cp -f player/nexusmediaplayer.core-portrait.swf /home/appspace/nexusmediaplayer.core-portrait.swf
	cp -f scripts/rebootscript.sh /home/appspace/rebootscript.sh
	cp -f scripts/killallappspaceprocess.sh /home/appspace/killallappspaceprocess.sh
	cp -f scripts/installation_340.sh /home/appspace/installation_340.sh
	cp -f scripts/installation.sh /home/appspace/installation.sh
	cp -f scripts/crontab /home/appspace/crontab
	cp -f scripts/appspacemonitor.sh /home/appspace/appspacemonitor.sh
	cp -f scripts/launcher /home/appspace/launcher	
	cp -f scripts/.post-install.sh /home/.post-install.sh
	cp -f scripts/.post-install.sh /home/.post-install
	cp -f scripts/autologin /home/appspace/autologin
	cp -f scripts/switchmode.sh /home/appspace/switchmode.sh
	cp -f scripts/switchorientation.sh /home/appspace/switchorientation.sh
	cp -f scripts/checkres.sh /home/appspace/checkres.sh
	cp -f scripts/checkproxy.sh /home/appspace/checkproxy.sh
	
	[[ -d /home/appspace/sip/ ]] && rm -rf /home/appspace/sip/
	mkdir -p /home/appspace/sip/
	
	cp -f scripts/sipclient.min.js /home/appspace/sip/sipclient.min.js
	
	[[ -d /apps/nexus2/pages ]] && rm -rf /apps/nexus2/pages
	mkdir /apps/nexus2/pages
	[[ -d pages/pm ]] && cp -rf pages/pm /apps/nexus2/pages/	
	[[ -d pages/splash ]] && cp -rf pages/splash /apps/nexus2/pages/
	
	dos2unix /home/appspace/rebootscript.sh > /dev/null
	dos2unix /home/appspace/killallappspaceprocess.sh > /dev/null
	dos2unix /home/appspace/installation_340.sh > /dev/null
	dos2unix /home/appspace/installation.sh > /dev/null
	dos2unix /home/appspace/crontab > /dev/null
	dos2unix /home/appspace/appspacemonitor.sh > /dev/null
	dos2unix /home/appspace/launcher > /dev/null
	dos2unix /home/.post-install.sh > /dev/null
	dos2unix /home/.post-install > /dev/null
	dos2unix /home/appspace/autologin > /dev/null
	dos2unix /home/appspace/switchmode.sh > /dev/null
	dos2unix /home/appspace/switchorientation.sh > /dev/null
	dos2unix /home/appspace/checkres.sh > /dev/null
	dos2unix /home/appspace/checkproxy.sh > /dev/null
	
	chmod a+rwx /home/appspace/rebootscript.sh
	chmod a+rwx /home/appspace/killallappspaceprocess.sh
	chmod a+rwx /home/appspace/installation_340.sh
	chmod a+rwx /home/appspace/installation.sh	
	chmod a+rwx /home/appspace/crontab
	chmod a+rwx /home/appspace/appspacemonitor.sh
	chmod a+rwx /home/appspace/launcher
	chmod a+rwx /home/.post-install.sh
	chmod a+rwx /home/.post-install
	chmod a+rwx /home/appspace/switchmode.sh
	chmod a+rwx /home/appspace/switchorientation.sh
	chmod a+rwx /home/appspace/checkres.sh
	chmod a+rwx /home/appspace/checkproxy.sh > /dev/null
	
	cp -f scripts/downloadmanagerEdge300.sh /home/appspace/downloadmanageredge300.sh
	cp -f scripts/dmholder.sh /home/appspace/dmholder.sh
	
	dos2unix /home/appspace/downloadmanageredge300.sh > /dev/null
	dos2unix /home/appspace/dmholder.sh > /dev/null
	chmod a+rwx /home/appspace/downloadmanageredge300.sh
	chmod a+rwx /home/appspace/dmholder.sh
	
	cp -f scripts/admholder.sh /home/appspace/admholder.sh
	cp -f scripts/commholder.sh /home/appspace/commholder.sh
	cp -f scripts/appspacenodeservicesholder.sh /home/appspace/appspacenodeservicesholder.sh
	cp -f scripts/node /home/appspace/node
	
	dos2unix /home/appspace/admholder.sh > /dev/null
	chmod a+rwx /home/appspace/admholder.sh
	dos2unix /home/appspace/commholder.sh > /dev/null
	chmod a+rwx /home/appspace/commholder.sh
	dos2unix /home/appspace/appspacenodeservicesholder.sh > /dev/null
	chmod a+rwx /home/appspace/appspacenodeservicesholder.sh
	
	chmod a+rwx /home/appspace/node
}

function ConfigureNodeProjects()
{
	if [ -d nodescripts/appspacecomm ] ; then
		[[ -d /home/appspace/nodescripts/appspacecomm ]] && : || mkdir -p /home/appspace/nodescripts/appspacecomm
		cp -rf nodescripts/appspacecomm/* /home/appspace/nodescripts/appspacecomm/
	fi
	
	if [ -d nodescripts/appspacenode ] ; then
		[[ -d /home/appspace/nodescripts/appspacenode ]] && : || mkdir -p /home/appspace/nodescripts/appspacenode
		cp -rf nodescripts/appspacenode/* /home/appspace/nodescripts/appspacenode/
	fi
	
	if [ -d nodescripts/appspacenodeservices ] ; then
		[[ -d /home/appspace/nodescripts/appspacenodeservices ]] && : || mkdir -p /home/appspace/nodescripts/appspacenodeservices
		cp -rf nodescripts/appspacenodeservices/* /home/appspace/nodescripts/appspacenodeservices/
	fi
}

function RemoveLegacyConfiguration()
{
	rm -rf /etc/xdg/autostart/appspace*
}

function ProcessData()
{
	local procDataPath="/run/appspace/process.data"
	local message="$1"
	touch "$procDataPath"
	echo "$message" > "$procDataPath"
	local procData=""
	dos2unix "$procDataPath" > /dev/null
	while read processdataline
	do
		procData="$processdataline"
	done < "$procDataPath"
	
	_REPLY="$procData"								
	rm -rf "$procDataPath"
}

function GetMACAddress(){
	REPLY=""
	
	local macraw=`ifconfig | grep eth0`
	macraw=`echo $macraw | sed 's|eth0||'`
	macraw=`echo $macraw | sed 's|Link encap:Ethernet||'`
	macraw=`echo $macraw | sed 's|HWaddr||'`
	macraw=`echo $macraw | sed 's/ *$//g'`
	ProcessData "$macraw"
	macraw="$_REPLY"
	REPLY="$macraw"
}

function SendDeviceType()
{
	local countline=0
	local id=""
	local appspaceip=""
	local devicetype=""
	
	while read -r line
	do
		if [[ $countline == 0 ]] ; then
			id="$line"
		elif [[ $countline == 2 ]] ; then
			appspaceip="$line"
		elif [[ $countline == 1 ]] ; then
			devicetype="$line"
		fi
		countline=$(($countline+1))
	done < /apps/nexus2/node.dat
	
	local res=$(curl -L -k --connect-timeout 30 --url "$appspaceip/integrationwebservices/ConfigScriptHandler.ashx" -d "operation=setproperty&key=Player.Model.Name&value=EDGE340&type=player&id=$id")
}

function CheckLegacyId()
{
	
	local countline=0
	local id=""
	local appspaceip=""
	
	while read -r line
	do
		if [[ $countline == 0 ]] ; then
			id="$line"
		elif [[ $countline == 2 ]] ; then
			appspaceip="$line"
		fi
		countline=$(($countline+1))
	done < /apps/nexus2/node.dat
	
	if [ `echo "$id" | grep "^[0-9]*$"` ]; then
		GetMACAddress
		local mac="$REPLY"
		local res=$(curl -L -k --connect-timeout 30 --url "$appspaceip/integrationwebservices/licensehandler.ashx" -d "query=license.getdeviceguidfromlegacy&pid=$id&di=$mac")
		if [ "$res" = "" ] ; then
			:
		elif [[ "$res" = *"API must"* ]] ; then
			:		
		else
			countline=0
			touch /run/appspace/node.dat.tmp
			while read -r line
			do
				if [[ $countline == 0 ]] ; then
					echo "$res" >> /run/appspace/node.dat.tmp
				else
					echo "$line" >> /run/appspace/node.dat.tmp
				fi
				countline=$(($countline+1))
			done < "/apps/nexus2/node.dat"
			cp -f /run/appspace/node.dat.tmp /apps/nexus2/node.dat
			rm -f /run/appspace/node.dat.tmp
		fi
	fi
}

function Start()
{
	[[ -d /run/appspace ]] && : || mkdir -p /run/appspace
	[[ -d /home/appspace ]] && : || mkdir -p /home/appspace
	[[ -d /apps ]] && : || mkdir -p /apps
	[[ -d /apps/nexus2 ]] && : || ln -s /home/appspace /apps/nexus2
	
	chown user:user /home/appspace
	chmod a+rw /home/appspace
	chown user:user /run/appspace
	chmod a+rw /run/appspace
	chown user:user /apps/nexus2
	chmod a+rw /apps/nexus2
	
	if [ "$1" = "clearworkingfolder" ] ; then
		rm -rf $(echo /home/appspace/* | tr " " "\n" | grep -v contentrepo | tr "\n" " ")
	fi
	
	CopyFiles
	ConfigureNodeProjects
	RemoveLegacyConfiguration
	CheckLegacyId
	SendDeviceType
	touch /home/appspace/install-reboot
}

Start $*